var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { r as registerInstance, h, g as getElement } from './core-dc91389b.js';
var keys = ['inputs', 'outputs', 'props', 'events', 'methods'];
var Api = /** @class */ (function () {
    function Api(hostRef) {
        registerInstance(this, hostRef);
    }
    Api.prototype.hasApi = function () {
        if (!this.doc) {
            return false;
        }
        for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
            var k = keys_1[_i];
            if (this.doc[k] && this.doc[k].length > 0) {
                return true;
            }
        }
    };
    Api.prototype.angular = function () {
        return [
            this.doc.inputs ? this.doc.inputs.map(function (i) { return h("ad-input-def", { input: i }); }) : undefined,
            this.doc.outputs ? this.doc.outputs.map(function (i) { return h("ad-output-def", { output: i }); }) : undefined,
            this.doc.props ? this.doc.props.map(function (i) { return h("ad-prop-def", { prop: i }); }) : undefined
        ];
    };
    Api.prototype.stencil = function () {
        return [
            this.doc.props ? this.doc.props.map(function (i) { return h("ad-prop-def", { prop: i }); }) : undefined,
            this.doc.events ? this.doc.events.map(function (i) { return h("ad-event-def", { event: i }); }) : undefined,
        ];
    };
    Api.prototype.render = function () {
        if (!this.hasApi()) {
            return undefined;
        }
        var isAngular = !this.doc.tag;
        return (h("article", { id: "api", class: "api" }, h("h2", null, "API"), isAngular ? this.angular() : this.stencil(), this.doc.methods ? this.doc.methods.map(function (i) { return h("ad-method-def", { method: i }); }) : undefined));
    };
    Object.defineProperty(Api, "style", {
        get: function () { return ".sc-ad-api-h{display:block;font-size:.875rem;font-family:var(--anj-font-family);font-weight:400;line-height:1.5;outline:none}.sc-ad-api-h, .sc-ad-api-h:after, .sc-ad-api-h:before{-webkit-box-sizing:border-box;box-sizing:border-box;outline:none}.sc-ad-api-h:active, .sc-ad-api-h .sc-ad-api:active, .sc-ad-api-h:focus, .sc-ad-api-h .sc-ad-api:focus{outline:none}.sc-ad-api-h .api.sc-ad-api{border-bottom:1px solid var(--anj-border);margin-bottom:3rem;padding-bottom:3rem}.sc-ad-api-h .api.sc-ad-api h2.sc-ad-api{margin-bottom:1.5rem}"; },
        enumerable: true,
        configurable: true
    });
    return Api;
}());
var ApiName = /** @class */ (function () {
    function ApiName(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(ApiName, "style", {
        get: function () { return "ad-api-name{display:inline;font-size:.875rem;font-family:var(--anj-font-family);font-weight:400;line-height:1.5;outline:none}ad-api-name,ad-api-name:after,ad-api-name:before{-webkit-box-sizing:border-box;box-sizing:border-box;outline:none}ad-api-name:active,ad-api-name :active,ad-api-name:focus,ad-api-name :focus{outline:none}ad-api-name:after{color:var(--anj-secondary-dark);content:\":\";margin-right:.5rem}"; },
        enumerable: true,
        configurable: true
    });
    return ApiName;
}());
var ArgDef = /** @class */ (function () {
    function ArgDef(hostRef) {
        registerInstance(this, hostRef);
    }
    ArgDef.prototype.render = function () {
        return [
            h("ad-api-name", null, this.arg.name),
            h("ad-type-def", null, this.arg.type)
        ];
    };
    Object.defineProperty(ArgDef, "style", {
        get: function () { return "ad-arg-def{display:inline;font-size:.875rem;font-family:var(--anj-font-family);font-weight:400;line-height:1.5;outline:none}ad-arg-def,ad-arg-def:after,ad-arg-def:before{-webkit-box-sizing:border-box;box-sizing:border-box;outline:none}ad-arg-def:active,ad-arg-def :active,ad-arg-def:focus,ad-arg-def :focus{outline:none}ad-arg-def:after{color:var(--anj-secondary-dark);content:\",\";margin-right:.5rem}ad-arg-def:last-child:after{content:none;margin-right:0}"; },
        enumerable: true,
        configurable: true
    });
    return ArgDef;
}());
var Decorator = /** @class */ (function () {
    function Decorator(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(Decorator, "style", {
        get: function () { return "ad-decorator{color:var(--anj-secondary-dark)}.api.ng ad-method-def ad-decorator,.api.ng ad-prop-def ad-decorator{display:none}"; },
        enumerable: true,
        configurable: true
    });
    return Decorator;
}());
var EventDef = /** @class */ (function () {
    function EventDef(hostRef) {
        registerInstance(this, hostRef);
    }
    EventDef.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Event"), "\u00A0", h("ad-api-name", null, this.event.event), h("ad-type-def", null, "<", this.event.detail, ">")),
            h("p", null, this.event.docs)
        ];
    };
    Object.defineProperty(EventDef, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return EventDef;
}());
var InputDef = /** @class */ (function () {
    function InputDef(hostRef) {
        registerInstance(this, hostRef);
    }
    InputDef.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Input\u00A0"), h("ad-api-name", null, this.input.name), h("ad-type-def", null, this.input.type)),
            h("p", null, this.input.docs)
        ];
    };
    Object.defineProperty(InputDef, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return InputDef;
}());
var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};
function createCommonjsModule(fn, module) {
    return module = { exports: {} }, fn(module, module.exports), module.exports;
}
var marked = createCommonjsModule(function (module, exports) {
    (function (root) {
        /**
         * Block-Level Grammar
         */
        var block = {
            newline: /^\n+/,
            code: /^( {4}[^\n]+\n*)+/,
            fences: noop,
            hr: /^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,
            heading: /^ *(#{1,6}) *([^\n]+?) *#* *(?:\n+|$)/,
            nptable: noop,
            blockquote: /^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,
            list: /^( *)(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,
            html: /^ *(?:comment *(?:\n|\s*$)|closed *(?:\n{2,}|\s*$)|closing *(?:\n{2,}|\s*$))/,
            def: /^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,
            table: noop,
            lheading: /^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,
            paragraph: /^([^\n]+(?:\n?(?!hr|heading|lheading| {0,3}>|tag)[^\n]+)+)/,
            text: /^[^\n]+/
        };
        block._label = /(?:\\[\[\]]|[^\[\]])+/;
        block._title = /(?:"(?:\\"|[^"]|"[^"\n]*")*"|'\n?(?:[^'\n]+\n?)*'|\([^()]*\))/;
        block.def = edit(block.def)
            .replace('label', block._label)
            .replace('title', block._title)
            .getRegex();
        block.bullet = /(?:[*+-]|\d+\.)/;
        block.item = /^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/;
        block.item = edit(block.item, 'gm')
            .replace(/bull/g, block.bullet)
            .getRegex();
        block.list = edit(block.list)
            .replace(/bull/g, block.bullet)
            .replace('hr', '\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))')
            .replace('def', '\\n+(?=' + block.def.source + ')')
            .getRegex();
        block._tag = '(?!(?:'
            + 'a|em|strong|small|s|cite|q|dfn|abbr|data|time|code'
            + '|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo'
            + '|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b';
        block.html = edit(block.html)
            .replace('comment', /<!--[\s\S]*?-->/)
            .replace('closed', /<(tag)[\s\S]+?<\/\1>/)
            .replace('closing', /<tag(?:"[^"]*"|'[^']*'|\s[^'"\/>\s]*)*?\/?>/)
            .replace(/tag/g, block._tag)
            .getRegex();
        block.paragraph = edit(block.paragraph)
            .replace('hr', block.hr)
            .replace('heading', block.heading)
            .replace('lheading', block.lheading)
            .replace('tag', '<' + block._tag)
            .getRegex();
        block.blockquote = edit(block.blockquote)
            .replace('paragraph', block.paragraph)
            .getRegex();
        /**
         * Normal Block Grammar
         */
        block.normal = merge({}, block);
        /**
         * GFM Block Grammar
         */
        block.gfm = merge({}, block.normal, {
            fences: /^ *(`{3,}|~{3,})[ \.]*(\S+)? *\n([\s\S]*?)\n? *\1 *(?:\n+|$)/,
            paragraph: /^/,
            heading: /^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/
        });
        block.gfm.paragraph = edit(block.paragraph)
            .replace('(?!', '(?!'
            + block.gfm.fences.source.replace('\\1', '\\2') + '|'
            + block.list.source.replace('\\1', '\\3') + '|')
            .getRegex();
        /**
         * GFM + Tables Block Grammar
         */
        block.tables = merge({}, block.gfm, {
            nptable: /^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,
            table: /^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/
        });
        /**
         * Block Lexer
         */
        function Lexer(options) {
            this.tokens = [];
            this.tokens.links = {};
            this.options = options || marked.defaults;
            this.rules = block.normal;
            if (this.options.gfm) {
                if (this.options.tables) {
                    this.rules = block.tables;
                }
                else {
                    this.rules = block.gfm;
                }
            }
        }
        /**
         * Expose Block Rules
         */
        Lexer.rules = block;
        /**
         * Static Lex Method
         */
        Lexer.lex = function (src, options) {
            var lexer = new Lexer(options);
            return lexer.lex(src);
        };
        /**
         * Preprocessing
         */
        Lexer.prototype.lex = function (src) {
            src = src
                .replace(/\r\n|\r/g, '\n')
                .replace(/\t/g, '    ')
                .replace(/\u00a0/g, ' ')
                .replace(/\u2424/g, '\n');
            return this.token(src, true);
        };
        /**
         * Lexing
         */
        Lexer.prototype.token = function (src, top) {
            src = src.replace(/^ +$/gm, '');
            var next, loose, cap, bull, b, item, space, i, tag, l, isordered;
            while (src) {
                // newline
                if (cap = this.rules.newline.exec(src)) {
                    src = src.substring(cap[0].length);
                    if (cap[0].length > 1) {
                        this.tokens.push({
                            type: 'space'
                        });
                    }
                }
                // code
                if (cap = this.rules.code.exec(src)) {
                    src = src.substring(cap[0].length);
                    cap = cap[0].replace(/^ {4}/gm, '');
                    this.tokens.push({
                        type: 'code',
                        text: !this.options.pedantic
                            ? cap.replace(/\n+$/, '')
                            : cap
                    });
                    continue;
                }
                // fences (gfm)
                if (cap = this.rules.fences.exec(src)) {
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: 'code',
                        lang: cap[2],
                        text: cap[3] || ''
                    });
                    continue;
                }
                // heading
                if (cap = this.rules.heading.exec(src)) {
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: 'heading',
                        depth: cap[1].length,
                        text: cap[2]
                    });
                    continue;
                }
                // table no leading pipe (gfm)
                if (top && (cap = this.rules.nptable.exec(src))) {
                    src = src.substring(cap[0].length);
                    item = {
                        type: 'table',
                        header: cap[1].replace(/^ *| *\| *$/g, '').split(/ *\| */),
                        align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
                        cells: cap[3].replace(/\n$/, '').split('\n')
                    };
                    for (i = 0; i < item.align.length; i++) {
                        if (/^ *-+: *$/.test(item.align[i])) {
                            item.align[i] = 'right';
                        }
                        else if (/^ *:-+: *$/.test(item.align[i])) {
                            item.align[i] = 'center';
                        }
                        else if (/^ *:-+ *$/.test(item.align[i])) {
                            item.align[i] = 'left';
                        }
                        else {
                            item.align[i] = null;
                        }
                    }
                    for (i = 0; i < item.cells.length; i++) {
                        item.cells[i] = item.cells[i].split(/ *\| */);
                    }
                    this.tokens.push(item);
                    continue;
                }
                // hr
                if (cap = this.rules.hr.exec(src)) {
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: 'hr'
                    });
                    continue;
                }
                // blockquote
                if (cap = this.rules.blockquote.exec(src)) {
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: 'blockquote_start'
                    });
                    cap = cap[0].replace(/^ *> ?/gm, '');
                    // Pass `top` to keep the current
                    // "toplevel" state. This is exactly
                    // how markdown.pl works.
                    this.token(cap, top);
                    this.tokens.push({
                        type: 'blockquote_end'
                    });
                    continue;
                }
                // list
                if (cap = this.rules.list.exec(src)) {
                    src = src.substring(cap[0].length);
                    bull = cap[2];
                    isordered = bull.length > 1;
                    this.tokens.push({
                        type: 'list_start',
                        ordered: isordered,
                        start: isordered ? +bull : ''
                    });
                    // Get each top-level item.
                    cap = cap[0].match(this.rules.item);
                    next = false;
                    l = cap.length;
                    i = 0;
                    for (; i < l; i++) {
                        item = cap[i];
                        // Remove the list item's bullet
                        // so it is seen as the next token.
                        space = item.length;
                        item = item.replace(/^ *([*+-]|\d+\.) +/, '');
                        // Outdent whatever the
                        // list item contains. Hacky.
                        if (~item.indexOf('\n ')) {
                            space -= item.length;
                            item = !this.options.pedantic
                                ? item.replace(new RegExp('^ {1,' + space + '}', 'gm'), '')
                                : item.replace(/^ {1,4}/gm, '');
                        }
                        // Determine whether the next list item belongs here.
                        // Backpedal if it does not belong in this list.
                        if (this.options.smartLists && i !== l - 1) {
                            b = block.bullet.exec(cap[i + 1])[0];
                            if (bull !== b && !(bull.length > 1 && b.length > 1)) {
                                src = cap.slice(i + 1).join('\n') + src;
                                i = l - 1;
                            }
                        }
                        // Determine whether item is loose or not.
                        // Use: /(^|\n)(?! )[^\n]+\n\n(?!\s*$)/
                        // for discount behavior.
                        loose = next || /\n\n(?!\s*$)/.test(item);
                        if (i !== l - 1) {
                            next = item.charAt(item.length - 1) === '\n';
                            if (!loose)
                                loose = next;
                        }
                        this.tokens.push({
                            type: loose
                                ? 'loose_item_start'
                                : 'list_item_start'
                        });
                        // Recurse.
                        this.token(item, false);
                        this.tokens.push({
                            type: 'list_item_end'
                        });
                    }
                    this.tokens.push({
                        type: 'list_end'
                    });
                    continue;
                }
                // html
                if (cap = this.rules.html.exec(src)) {
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: this.options.sanitize
                            ? 'paragraph'
                            : 'html',
                        pre: !this.options.sanitizer
                            && (cap[1] === 'pre' || cap[1] === 'script' || cap[1] === 'style'),
                        text: cap[0]
                    });
                    continue;
                }
                // def
                if (top && (cap = this.rules.def.exec(src))) {
                    src = src.substring(cap[0].length);
                    if (cap[3])
                        cap[3] = cap[3].substring(1, cap[3].length - 1);
                    tag = cap[1].toLowerCase();
                    if (!this.tokens.links[tag]) {
                        this.tokens.links[tag] = {
                            href: cap[2],
                            title: cap[3]
                        };
                    }
                    continue;
                }
                // table (gfm)
                if (top && (cap = this.rules.table.exec(src))) {
                    src = src.substring(cap[0].length);
                    item = {
                        type: 'table',
                        header: cap[1].replace(/^ *| *\| *$/g, '').split(/ *\| */),
                        align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
                        cells: cap[3].replace(/(?: *\| *)?\n$/, '').split('\n')
                    };
                    for (i = 0; i < item.align.length; i++) {
                        if (/^ *-+: *$/.test(item.align[i])) {
                            item.align[i] = 'right';
                        }
                        else if (/^ *:-+: *$/.test(item.align[i])) {
                            item.align[i] = 'center';
                        }
                        else if (/^ *:-+ *$/.test(item.align[i])) {
                            item.align[i] = 'left';
                        }
                        else {
                            item.align[i] = null;
                        }
                    }
                    for (i = 0; i < item.cells.length; i++) {
                        item.cells[i] = item.cells[i]
                            .replace(/^ *\| *| *\| *$/g, '')
                            .split(/ *\| */);
                    }
                    this.tokens.push(item);
                    continue;
                }
                // lheading
                if (cap = this.rules.lheading.exec(src)) {
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: 'heading',
                        depth: cap[2] === '=' ? 1 : 2,
                        text: cap[1]
                    });
                    continue;
                }
                // top-level paragraph
                if (top && (cap = this.rules.paragraph.exec(src))) {
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: 'paragraph',
                        text: cap[1].charAt(cap[1].length - 1) === '\n'
                            ? cap[1].slice(0, -1)
                            : cap[1]
                    });
                    continue;
                }
                // text
                if (cap = this.rules.text.exec(src)) {
                    // Top-level should never reach here.
                    src = src.substring(cap[0].length);
                    this.tokens.push({
                        type: 'text',
                        text: cap[0]
                    });
                    continue;
                }
                if (src) {
                    throw new Error('Infinite loop on byte: ' + src.charCodeAt(0));
                }
            }
            return this.tokens;
        };
        /**
         * Inline-Level Grammar
         */
        var inline = {
            escape: /^\\([\\`*{}\[\]()#+\-.!_>])/,
            autolink: /^<(scheme:[^\s\x00-\x1f<>]*|email)>/,
            url: noop,
            tag: /^<!--[\s\S]*?-->|^<\/?[a-zA-Z0-9\-]+(?:"[^"]*"|'[^']*'|\s[^<'">\/\s]*)*?\/?>/,
            link: /^!?\[(inside)\]\(href\)/,
            reflink: /^!?\[(inside)\]\s*\[([^\]]*)\]/,
            nolink: /^!?\[((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\]/,
            strong: /^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,
            em: /^_([^\s_](?:[^_]|__)+?[^\s_])_\b|^\*((?:\*\*|[^*])+?)\*(?!\*)/,
            code: /^(`+)\s*([\s\S]*?[^`]?)\s*\1(?!`)/,
            br: /^ {2,}\n(?!\s*$)/,
            del: noop,
            text: /^[\s\S]+?(?=[\\<!\[`*]|\b_| {2,}\n|$)/
        };
        inline._scheme = /[a-zA-Z][a-zA-Z0-9+.-]{1,31}/;
        inline._email = /[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/;
        inline.autolink = edit(inline.autolink)
            .replace('scheme', inline._scheme)
            .replace('email', inline._email)
            .getRegex();
        inline._inside = /(?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]]|\](?=[^\[]*\]))*/;
        inline._href = /\s*<?([\s\S]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*/;
        inline.link = edit(inline.link)
            .replace('inside', inline._inside)
            .replace('href', inline._href)
            .getRegex();
        inline.reflink = edit(inline.reflink)
            .replace('inside', inline._inside)
            .getRegex();
        /**
         * Normal Inline Grammar
         */
        inline.normal = merge({}, inline);
        /**
         * Pedantic Inline Grammar
         */
        inline.pedantic = merge({}, inline.normal, {
            strong: /^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,
            em: /^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/
        });
        /**
         * GFM Inline Grammar
         */
        inline.gfm = merge({}, inline.normal, {
            escape: edit(inline.escape).replace('])', '~|])').getRegex(),
            url: edit(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/)
                .replace('email', inline._email)
                .getRegex(),
            _backpedal: /(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,
            del: /^~~(?=\S)([\s\S]*?\S)~~/,
            text: edit(inline.text)
                .replace(']|', '~]|')
                .replace('|', '|https?://|ftp://|www\\.|[a-zA-Z0-9.!#$%&\'*+/=?^_`{\\|}~-]+@|')
                .getRegex()
        });
        /**
         * GFM + Line Breaks Inline Grammar
         */
        inline.breaks = merge({}, inline.gfm, {
            br: edit(inline.br).replace('{2,}', '*').getRegex(),
            text: edit(inline.gfm.text).replace('{2,}', '*').getRegex()
        });
        /**
         * Inline Lexer & Compiler
         */
        function InlineLexer(links, options) {
            this.options = options || marked.defaults;
            this.links = links;
            this.rules = inline.normal;
            this.renderer = this.options.renderer || new Renderer();
            this.renderer.options = this.options;
            if (!this.links) {
                throw new Error('Tokens array requires a `links` property.');
            }
            if (this.options.gfm) {
                if (this.options.breaks) {
                    this.rules = inline.breaks;
                }
                else {
                    this.rules = inline.gfm;
                }
            }
            else if (this.options.pedantic) {
                this.rules = inline.pedantic;
            }
        }
        /**
         * Expose Inline Rules
         */
        InlineLexer.rules = inline;
        /**
         * Static Lexing/Compiling Method
         */
        InlineLexer.output = function (src, links, options) {
            var inline = new InlineLexer(links, options);
            return inline.output(src);
        };
        /**
         * Lexing/Compiling
         */
        InlineLexer.prototype.output = function (src) {
            var out = '', link, text, href, cap;
            while (src) {
                // escape
                if (cap = this.rules.escape.exec(src)) {
                    src = src.substring(cap[0].length);
                    out += cap[1];
                    continue;
                }
                // autolink
                if (cap = this.rules.autolink.exec(src)) {
                    src = src.substring(cap[0].length);
                    if (cap[2] === '@') {
                        text = escape(this.mangle(cap[1]));
                        href = 'mailto:' + text;
                    }
                    else {
                        text = escape(cap[1]);
                        href = text;
                    }
                    out += this.renderer.link(href, null, text);
                    continue;
                }
                // url (gfm)
                if (!this.inLink && (cap = this.rules.url.exec(src))) {
                    cap[0] = this.rules._backpedal.exec(cap[0])[0];
                    src = src.substring(cap[0].length);
                    if (cap[2] === '@') {
                        text = escape(cap[0]);
                        href = 'mailto:' + text;
                    }
                    else {
                        text = escape(cap[0]);
                        if (cap[1] === 'www.') {
                            href = 'http://' + text;
                        }
                        else {
                            href = text;
                        }
                    }
                    out += this.renderer.link(href, null, text);
                    continue;
                }
                // tag
                if (cap = this.rules.tag.exec(src)) {
                    if (!this.inLink && /^<a /i.test(cap[0])) {
                        this.inLink = true;
                    }
                    else if (this.inLink && /^<\/a>/i.test(cap[0])) {
                        this.inLink = false;
                    }
                    src = src.substring(cap[0].length);
                    out += this.options.sanitize
                        ? this.options.sanitizer
                            ? this.options.sanitizer(cap[0])
                            : escape(cap[0])
                        : cap[0];
                    continue;
                }
                // link
                if (cap = this.rules.link.exec(src)) {
                    src = src.substring(cap[0].length);
                    this.inLink = true;
                    out += this.outputLink(cap, {
                        href: cap[2],
                        title: cap[3]
                    });
                    this.inLink = false;
                    continue;
                }
                // reflink, nolink
                if ((cap = this.rules.reflink.exec(src))
                    || (cap = this.rules.nolink.exec(src))) {
                    src = src.substring(cap[0].length);
                    link = (cap[2] || cap[1]).replace(/\s+/g, ' ');
                    link = this.links[link.toLowerCase()];
                    if (!link || !link.href) {
                        out += cap[0].charAt(0);
                        src = cap[0].substring(1) + src;
                        continue;
                    }
                    this.inLink = true;
                    out += this.outputLink(cap, link);
                    this.inLink = false;
                    continue;
                }
                // strong
                if (cap = this.rules.strong.exec(src)) {
                    src = src.substring(cap[0].length);
                    out += this.renderer.strong(this.output(cap[2] || cap[1]));
                    continue;
                }
                // em
                if (cap = this.rules.em.exec(src)) {
                    src = src.substring(cap[0].length);
                    out += this.renderer.em(this.output(cap[2] || cap[1]));
                    continue;
                }
                // code
                if (cap = this.rules.code.exec(src)) {
                    src = src.substring(cap[0].length);
                    out += this.renderer.codespan(escape(cap[2].trim(), true));
                    continue;
                }
                // br
                if (cap = this.rules.br.exec(src)) {
                    src = src.substring(cap[0].length);
                    out += this.renderer.br();
                    continue;
                }
                // del (gfm)
                if (cap = this.rules.del.exec(src)) {
                    src = src.substring(cap[0].length);
                    out += this.renderer.del(this.output(cap[1]));
                    continue;
                }
                // text
                if (cap = this.rules.text.exec(src)) {
                    src = src.substring(cap[0].length);
                    out += this.renderer.text(escape(this.smartypants(cap[0])));
                    continue;
                }
                if (src) {
                    throw new Error('Infinite loop on byte: ' + src.charCodeAt(0));
                }
            }
            return out;
        };
        /**
         * Compile Link
         */
        InlineLexer.prototype.outputLink = function (cap, link) {
            var href = escape(link.href), title = link.title ? escape(link.title) : null;
            return cap[0].charAt(0) !== '!'
                ? this.renderer.link(href, title, this.output(cap[1]))
                : this.renderer.image(href, title, escape(cap[1]));
        };
        /**
         * Smartypants Transformations
         */
        InlineLexer.prototype.smartypants = function (text) {
            if (!this.options.smartypants)
                return text;
            return text
                // em-dashes
                .replace(/---/g, '\u2014')
                // en-dashes
                .replace(/--/g, '\u2013')
                // opening singles
                .replace(/(^|[-\u2014/(\[{"\s])'/g, '$1\u2018')
                // closing singles & apostrophes
                .replace(/'/g, '\u2019')
                // opening doubles
                .replace(/(^|[-\u2014/(\[{\u2018\s])"/g, '$1\u201c')
                // closing doubles
                .replace(/"/g, '\u201d')
                // ellipses
                .replace(/\.{3}/g, '\u2026');
        };
        /**
         * Mangle Links
         */
        InlineLexer.prototype.mangle = function (text) {
            if (!this.options.mangle)
                return text;
            var out = '', l = text.length, i = 0, ch;
            for (; i < l; i++) {
                ch = text.charCodeAt(i);
                if (Math.random() > 0.5) {
                    ch = 'x' + ch.toString(16);
                }
                out += '&#' + ch + ';';
            }
            return out;
        };
        /**
         * Renderer
         */
        function Renderer(options) {
            this.options = options || {};
        }
        Renderer.prototype.code = function (code, lang, escaped) {
            if (this.options.highlight) {
                var out = this.options.highlight(code, lang);
                if (out != null && out !== code) {
                    escaped = true;
                    code = out;
                }
            }
            if (!lang) {
                return '<pre><code>'
                    + (escaped ? code : escape(code, true))
                    + '\n</code></pre>';
            }
            return '<pre><code class="'
                + this.options.langPrefix
                + escape(lang, true)
                + '">'
                + (escaped ? code : escape(code, true))
                + '\n</code></pre>\n';
        };
        Renderer.prototype.blockquote = function (quote) {
            return '<blockquote>\n' + quote + '</blockquote>\n';
        };
        Renderer.prototype.html = function (html) {
            return html;
        };
        Renderer.prototype.heading = function (text, level, raw) {
            return '<h'
                + level
                + ' id="'
                + this.options.headerPrefix
                + raw.toLowerCase().replace(/[^\w]+/g, '-')
                + '">'
                + text
                + '</h'
                + level
                + '>\n';
        };
        Renderer.prototype.hr = function () {
            return this.options.xhtml ? '<hr/>\n' : '<hr>\n';
        };
        Renderer.prototype.list = function (body, ordered, start) {
            var type = ordered ? 'ol' : 'ul', startatt = (ordered && start !== 1) ? (' start="' + start + '"') : '';
            return '<' + type + startatt + '>\n' + body + '</' + type + '>\n';
        };
        Renderer.prototype.listitem = function (text) {
            return '<li>' + text + '</li>\n';
        };
        Renderer.prototype.paragraph = function (text) {
            return '<p>' + text + '</p>\n';
        };
        Renderer.prototype.table = function (header, body) {
            return '<table>\n'
                + '<thead>\n'
                + header
                + '</thead>\n'
                + '<tbody>\n'
                + body
                + '</tbody>\n'
                + '</table>\n';
        };
        Renderer.prototype.tablerow = function (content) {
            return '<tr>\n' + content + '</tr>\n';
        };
        Renderer.prototype.tablecell = function (content, flags) {
            var type = flags.header ? 'th' : 'td';
            var tag = flags.align
                ? '<' + type + ' style="text-align:' + flags.align + '">'
                : '<' + type + '>';
            return tag + content + '</' + type + '>\n';
        };
        // span level renderer
        Renderer.prototype.strong = function (text) {
            return '<strong>' + text + '</strong>';
        };
        Renderer.prototype.em = function (text) {
            return '<em>' + text + '</em>';
        };
        Renderer.prototype.codespan = function (text) {
            return '<code>' + text + '</code>';
        };
        Renderer.prototype.br = function () {
            return this.options.xhtml ? '<br/>' : '<br>';
        };
        Renderer.prototype.del = function (text) {
            return '<del>' + text + '</del>';
        };
        Renderer.prototype.link = function (href, title, text) {
            if (this.options.sanitize) {
                try {
                    var prot = decodeURIComponent(unescape(href))
                        .replace(/[^\w:]/g, '')
                        .toLowerCase();
                }
                catch (e) {
                    return text;
                }
                if (prot.indexOf('javascript:') === 0 || prot.indexOf('vbscript:') === 0 || prot.indexOf('data:') === 0) {
                    return text;
                }
            }
            if (this.options.baseUrl && !originIndependentUrl.test(href)) {
                href = resolveUrl(this.options.baseUrl, href);
            }
            var out = '<a href="' + href + '"';
            if (title) {
                out += ' title="' + title + '"';
            }
            out += '>' + text + '</a>';
            return out;
        };
        Renderer.prototype.image = function (href, title, text) {
            if (this.options.baseUrl && !originIndependentUrl.test(href)) {
                href = resolveUrl(this.options.baseUrl, href);
            }
            var out = '<img src="' + href + '" alt="' + text + '"';
            if (title) {
                out += ' title="' + title + '"';
            }
            out += this.options.xhtml ? '/>' : '>';
            return out;
        };
        Renderer.prototype.text = function (text) {
            return text;
        };
        /**
         * TextRenderer
         * returns only the textual part of the token
         */
        function TextRenderer() { }
        // no need for block level renderers
        TextRenderer.prototype.strong =
            TextRenderer.prototype.em =
                TextRenderer.prototype.codespan =
                    TextRenderer.prototype.del =
                        TextRenderer.prototype.text = function (text) {
                            return text;
                        };
        TextRenderer.prototype.link =
            TextRenderer.prototype.image = function (href, title, text) {
                return '' + text;
            };
        TextRenderer.prototype.br = function () {
            return '';
        };
        /**
         * Parsing & Compiling
         */
        function Parser(options) {
            this.tokens = [];
            this.token = null;
            this.options = options || marked.defaults;
            this.options.renderer = this.options.renderer || new Renderer();
            this.renderer = this.options.renderer;
            this.renderer.options = this.options;
        }
        /**
         * Static Parse Method
         */
        Parser.parse = function (src, options) {
            var parser = new Parser(options);
            return parser.parse(src);
        };
        /**
         * Parse Loop
         */
        Parser.prototype.parse = function (src) {
            this.inline = new InlineLexer(src.links, this.options);
            // use an InlineLexer with a TextRenderer to extract pure text
            this.inlineText = new InlineLexer(src.links, merge({}, this.options, { renderer: new TextRenderer() }));
            this.tokens = src.reverse();
            var out = '';
            while (this.next()) {
                out += this.tok();
            }
            return out;
        };
        /**
         * Next Token
         */
        Parser.prototype.next = function () {
            return this.token = this.tokens.pop();
        };
        /**
         * Preview Next Token
         */
        Parser.prototype.peek = function () {
            return this.tokens[this.tokens.length - 1] || 0;
        };
        /**
         * Parse Text Tokens
         */
        Parser.prototype.parseText = function () {
            var body = this.token.text;
            while (this.peek().type === 'text') {
                body += '\n' + this.next().text;
            }
            return this.inline.output(body);
        };
        /**
         * Parse Current Token
         */
        Parser.prototype.tok = function () {
            switch (this.token.type) {
                case 'space': {
                    return '';
                }
                case 'hr': {
                    return this.renderer.hr();
                }
                case 'heading': {
                    return this.renderer.heading(this.inline.output(this.token.text), this.token.depth, unescape(this.inlineText.output(this.token.text)));
                }
                case 'code': {
                    return this.renderer.code(this.token.text, this.token.lang, this.token.escaped);
                }
                case 'table': {
                    var header = '', body = '', i, row, cell, j;
                    // header
                    cell = '';
                    for (i = 0; i < this.token.header.length; i++) {
                        cell += this.renderer.tablecell(this.inline.output(this.token.header[i]), { header: true, align: this.token.align[i] });
                    }
                    header += this.renderer.tablerow(cell);
                    for (i = 0; i < this.token.cells.length; i++) {
                        row = this.token.cells[i];
                        cell = '';
                        for (j = 0; j < row.length; j++) {
                            cell += this.renderer.tablecell(this.inline.output(row[j]), { header: false, align: this.token.align[j] });
                        }
                        body += this.renderer.tablerow(cell);
                    }
                    return this.renderer.table(header, body);
                }
                case 'blockquote_start': {
                    body = '';
                    while (this.next().type !== 'blockquote_end') {
                        body += this.tok();
                    }
                    return this.renderer.blockquote(body);
                }
                case 'list_start': {
                    body = '';
                    var ordered = this.token.ordered, start = this.token.start;
                    while (this.next().type !== 'list_end') {
                        body += this.tok();
                    }
                    return this.renderer.list(body, ordered, start);
                }
                case 'list_item_start': {
                    body = '';
                    while (this.next().type !== 'list_item_end') {
                        body += this.token.type === 'text'
                            ? this.parseText()
                            : this.tok();
                    }
                    return this.renderer.listitem(body);
                }
                case 'loose_item_start': {
                    body = '';
                    while (this.next().type !== 'list_item_end') {
                        body += this.tok();
                    }
                    return this.renderer.listitem(body);
                }
                case 'html': {
                    var html = !this.token.pre && !this.options.pedantic
                        ? this.inline.output(this.token.text)
                        : this.token.text;
                    return this.renderer.html(html);
                }
                case 'paragraph': {
                    return this.renderer.paragraph(this.inline.output(this.token.text));
                }
                case 'text': {
                    return this.renderer.paragraph(this.parseText());
                }
            }
        };
        /**
         * Helpers
         */
        function escape(html, encode) {
            return html
                .replace(!encode ? /&(?!#?\w+;)/g : /&/g, '&amp;')
                .replace(/</g, '&lt;')
                .replace(/>/g, '&gt;')
                .replace(/"/g, '&quot;')
                .replace(/'/g, '&#39;');
        }
        function unescape(html) {
            // explicitly match decimal, hex, and named HTML entities
            return html.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig, function (_, n) {
                n = n.toLowerCase();
                if (n === 'colon')
                    return ':';
                if (n.charAt(0) === '#') {
                    return n.charAt(1) === 'x'
                        ? String.fromCharCode(parseInt(n.substring(2), 16))
                        : String.fromCharCode(+n.substring(1));
                }
                return '';
            });
        }
        function edit(regex, opt) {
            regex = regex.source;
            opt = opt || '';
            return {
                replace: function (name, val) {
                    val = val.source || val;
                    val = val.replace(/(^|[^\[])\^/g, '$1');
                    regex = regex.replace(name, val);
                    return this;
                },
                getRegex: function () {
                    return new RegExp(regex, opt);
                }
            };
        }
        function resolveUrl(base, href) {
            if (!baseUrls[' ' + base]) {
                // we can ignore everything in base after the last slash of its path component,
                // but we might need to add _that_
                // https://tools.ietf.org/html/rfc3986#section-3
                if (/^[^:]+:\/*[^/]*$/.test(base)) {
                    baseUrls[' ' + base] = base + '/';
                }
                else {
                    baseUrls[' ' + base] = base.replace(/[^/]*$/, '');
                }
            }
            base = baseUrls[' ' + base];
            if (href.slice(0, 2) === '//') {
                return base.replace(/:[\s\S]*/, ':') + href;
            }
            else if (href.charAt(0) === '/') {
                return base.replace(/(:\/*[^/]*)[\s\S]*/, '$1') + href;
            }
            else {
                return base + href;
            }
        }
        var baseUrls = {};
        var originIndependentUrl = /^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;
        function noop() { }
        noop.exec = noop;
        function merge(obj) {
            var i = 1, target, key;
            for (; i < arguments.length; i++) {
                target = arguments[i];
                for (key in target) {
                    if (Object.prototype.hasOwnProperty.call(target, key)) {
                        obj[key] = target[key];
                    }
                }
            }
            return obj;
        }
        /**
         * Marked
         */
        function marked(src, opt, callback) {
            // throw error in case of non string input
            if (typeof src === 'undefined' || src === null) {
                throw new Error('marked(): input parameter is undefined or null');
            }
            if (typeof src !== 'string') {
                throw new Error('marked(): input parameter is of type '
                    + Object.prototype.toString.call(src) + ', string expected');
            }
            if (callback || typeof opt === 'function') {
                if (!callback) {
                    callback = opt;
                    opt = null;
                }
                opt = merge({}, marked.defaults, opt || {});
                var highlight = opt.highlight, tokens, pending, i = 0;
                try {
                    tokens = Lexer.lex(src, opt);
                }
                catch (e) {
                    return callback(e);
                }
                pending = tokens.length;
                var done = function (err) {
                    if (err) {
                        opt.highlight = highlight;
                        return callback(err);
                    }
                    var out;
                    try {
                        out = Parser.parse(tokens, opt);
                    }
                    catch (e) {
                        err = e;
                    }
                    opt.highlight = highlight;
                    return err
                        ? callback(err)
                        : callback(null, out);
                };
                if (!highlight || highlight.length < 3) {
                    return done();
                }
                delete opt.highlight;
                if (!pending)
                    return done();
                for (; i < tokens.length; i++) {
                    (function (token) {
                        if (token.type !== 'code') {
                            return --pending || done();
                        }
                        return highlight(token.text, token.lang, function (err, code) {
                            if (err)
                                return done(err);
                            if (code == null || code === token.text) {
                                return --pending || done();
                            }
                            token.text = code;
                            token.escaped = true;
                            --pending || done();
                        });
                    })(tokens[i]);
                }
                return;
            }
            try {
                if (opt)
                    opt = merge({}, marked.defaults, opt);
                return Parser.parse(Lexer.lex(src, opt), opt);
            }
            catch (e) {
                e.message += '\nPlease report this to https://github.com/markedjs/marked.';
                if ((opt || marked.defaults).silent) {
                    return '<p>An error occurred:</p><pre>'
                        + escape(e.message + '', true)
                        + '</pre>';
                }
                throw e;
            }
        }
        /**
         * Options
         */
        marked.options =
            marked.setOptions = function (opt) {
                merge(marked.defaults, opt);
                return marked;
            };
        marked.defaults = {
            gfm: true,
            tables: true,
            breaks: false,
            pedantic: false,
            sanitize: false,
            sanitizer: null,
            mangle: true,
            smartLists: false,
            silent: false,
            highlight: null,
            langPrefix: 'lang-',
            smartypants: false,
            headerPrefix: '',
            renderer: new Renderer(),
            xhtml: false,
            baseUrl: null
        };
        /**
         * Expose
         */
        marked.Parser = Parser;
        marked.parser = Parser.parse;
        marked.Renderer = Renderer;
        marked.TextRenderer = TextRenderer;
        marked.Lexer = Lexer;
        marked.lexer = Lexer.lex;
        marked.InlineLexer = InlineLexer;
        marked.inlineLexer = InlineLexer.output;
        marked.parse = marked;
        {
            module.exports = marked;
        }
    })();
});
var prism = createCommonjsModule(function (module) {
    /* **********************************************
         Begin prism-core.js
    ********************************************** */
    var _self = (typeof window !== 'undefined')
        ? window // if in browser
        : ((typeof WorkerGlobalScope !== 'undefined' && self instanceof WorkerGlobalScope)
            ? self // if in worker
            : {} // if in node js
        );
    /**
     * Prism: Lightweight, robust, elegant syntax highlighting
     * MIT license http://www.opensource.org/licenses/mit-license.php/
     * @author Lea Verou http://lea.verou.me
     */
    var Prism = (function () {
        // Private helper vars
        var lang = /\blang(?:uage)?-(\w+)\b/i;
        var uniqueId = 0;
        var _ = _self.Prism = {
            manual: _self.Prism && _self.Prism.manual,
            disableWorkerMessageHandler: _self.Prism && _self.Prism.disableWorkerMessageHandler,
            util: {
                encode: function (tokens) {
                    if (tokens instanceof Token) {
                        return new Token(tokens.type, _.util.encode(tokens.content), tokens.alias);
                    }
                    else if (_.util.type(tokens) === 'Array') {
                        return tokens.map(_.util.encode);
                    }
                    else {
                        return tokens.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/\u00a0/g, ' ');
                    }
                },
                type: function (o) {
                    return Object.prototype.toString.call(o).match(/\[object (\w+)\]/)[1];
                },
                objId: function (obj) {
                    if (!obj['__id']) {
                        Object.defineProperty(obj, '__id', { value: ++uniqueId });
                    }
                    return obj['__id'];
                },
                // Deep clone a language definition (e.g. to extend it)
                clone: function (o) {
                    var type = _.util.type(o);
                    switch (type) {
                        case 'Object':
                            var clone = {};
                            for (var key in o) {
                                if (o.hasOwnProperty(key)) {
                                    clone[key] = _.util.clone(o[key]);
                                }
                            }
                            return clone;
                        case 'Array':
                            return o.map(function (v) { return _.util.clone(v); });
                    }
                    return o;
                }
            },
            languages: {
                extend: function (id, redef) {
                    var lang = _.util.clone(_.languages[id]);
                    for (var key in redef) {
                        lang[key] = redef[key];
                    }
                    return lang;
                },
                /**
                 * Insert a token before another token in a language literal
                 * As this needs to recreate the object (we cannot actually insert before keys in object literals),
                 * we cannot just provide an object, we need anobject and a key.
                 * @param inside The key (or language id) of the parent
                 * @param before The key to insert before. If not provided, the function appends instead.
                 * @param insert Object with the key/value pairs to insert
                 * @param root The object that contains `inside`. If equal to Prism.languages, it can be omitted.
                 */
                insertBefore: function (inside, before, insert, root) {
                    root = root || _.languages;
                    var grammar = root[inside];
                    if (arguments.length == 2) {
                        insert = arguments[1];
                        for (var newToken in insert) {
                            if (insert.hasOwnProperty(newToken)) {
                                grammar[newToken] = insert[newToken];
                            }
                        }
                        return grammar;
                    }
                    var ret = {};
                    for (var token in grammar) {
                        if (grammar.hasOwnProperty(token)) {
                            if (token == before) {
                                for (var newToken in insert) {
                                    if (insert.hasOwnProperty(newToken)) {
                                        ret[newToken] = insert[newToken];
                                    }
                                }
                            }
                            ret[token] = grammar[token];
                        }
                    }
                    // Update references in other language definitions
                    _.languages.DFS(_.languages, function (key, value) {
                        if (value === root[inside] && key != inside) {
                            this[key] = ret;
                        }
                    });
                    return root[inside] = ret;
                },
                // Traverse a language definition with Depth First Search
                DFS: function (o, callback, type, visited) {
                    visited = visited || {};
                    for (var i in o) {
                        if (o.hasOwnProperty(i)) {
                            callback.call(o, i, o[i], type || i);
                            if (_.util.type(o[i]) === 'Object' && !visited[_.util.objId(o[i])]) {
                                visited[_.util.objId(o[i])] = true;
                                _.languages.DFS(o[i], callback, null, visited);
                            }
                            else if (_.util.type(o[i]) === 'Array' && !visited[_.util.objId(o[i])]) {
                                visited[_.util.objId(o[i])] = true;
                                _.languages.DFS(o[i], callback, i, visited);
                            }
                        }
                    }
                }
            },
            plugins: {},
            highlightAll: function (async, callback) {
                _.highlightAllUnder(document, async, callback);
            },
            highlightAllUnder: function (container, async, callback) {
                var env = {
                    callback: callback,
                    selector: 'code[class*="language-"], [class*="language-"] code, code[class*="lang-"], [class*="lang-"] code'
                };
                _.hooks.run("before-highlightall", env);
                var elements = env.elements || container.querySelectorAll(env.selector);
                for (var i = 0, element; element = elements[i++];) {
                    _.highlightElement(element, async === true, env.callback);
                }
            },
            highlightElement: function (element, async, callback) {
                // Find language
                var language, grammar, parent = element;
                while (parent && !lang.test(parent.className)) {
                    parent = parent.parentNode;
                }
                if (parent) {
                    language = (parent.className.match(lang) || [, ''])[1].toLowerCase();
                    grammar = _.languages[language];
                }
                // Set language on the element, if not present
                element.className = element.className.replace(lang, '').replace(/\s+/g, ' ') + ' language-' + language;
                if (element.parentNode) {
                    // Set language on the parent, for styling
                    parent = element.parentNode;
                    if (/pre/i.test(parent.nodeName)) {
                        parent.className = parent.className.replace(lang, '').replace(/\s+/g, ' ') + ' language-' + language;
                    }
                }
                var code = element.textContent;
                var env = {
                    element: element,
                    language: language,
                    grammar: grammar,
                    code: code
                };
                _.hooks.run('before-sanity-check', env);
                if (!env.code || !env.grammar) {
                    if (env.code) {
                        _.hooks.run('before-highlight', env);
                        env.element.textContent = env.code;
                        _.hooks.run('after-highlight', env);
                    }
                    _.hooks.run('complete', env);
                    return;
                }
                _.hooks.run('before-highlight', env);
                if (async && _self.Worker) {
                    var worker = new Worker(_.filename);
                    worker.onmessage = function (evt) {
                        env.highlightedCode = evt.data;
                        _.hooks.run('before-insert', env);
                        env.element.innerHTML = env.highlightedCode;
                        callback && callback.call(env.element);
                        _.hooks.run('after-highlight', env);
                        _.hooks.run('complete', env);
                    };
                    worker.postMessage(JSON.stringify({
                        language: env.language,
                        code: env.code,
                        immediateClose: true
                    }));
                }
                else {
                    env.highlightedCode = _.highlight(env.code, env.grammar, env.language);
                    _.hooks.run('before-insert', env);
                    env.element.innerHTML = env.highlightedCode;
                    callback && callback.call(element);
                    _.hooks.run('after-highlight', env);
                    _.hooks.run('complete', env);
                }
            },
            highlight: function (text, grammar, language) {
                var tokens = _.tokenize(text, grammar);
                return Token.stringify(_.util.encode(tokens), language);
            },
            matchGrammar: function (text, strarr, grammar, index, startPos, oneshot, target) {
                var Token = _.Token;
                for (var token in grammar) {
                    if (!grammar.hasOwnProperty(token) || !grammar[token]) {
                        continue;
                    }
                    if (token == target) {
                        return;
                    }
                    var patterns = grammar[token];
                    patterns = (_.util.type(patterns) === "Array") ? patterns : [patterns];
                    for (var j = 0; j < patterns.length; ++j) {
                        var pattern = patterns[j], inside = pattern.inside, lookbehind = !!pattern.lookbehind, greedy = !!pattern.greedy, lookbehindLength = 0, alias = pattern.alias;
                        if (greedy && !pattern.pattern.global) {
                            // Without the global flag, lastIndex won't work
                            var flags = pattern.pattern.toString().match(/[imuy]*$/)[0];
                            pattern.pattern = RegExp(pattern.pattern.source, flags + "g");
                        }
                        pattern = pattern.pattern || pattern;
                        // Don’t cache length as it changes during the loop
                        for (var i = index, pos = startPos; i < strarr.length; pos += strarr[i].length, ++i) {
                            var str = strarr[i];
                            if (strarr.length > text.length) {
                                // Something went terribly wrong, ABORT, ABORT!
                                return;
                            }
                            if (str instanceof Token) {
                                continue;
                            }
                            pattern.lastIndex = 0;
                            var match = pattern.exec(str), delNum = 1;
                            // Greedy patterns can override/remove up to two previously matched tokens
                            if (!match && greedy && i != strarr.length - 1) {
                                pattern.lastIndex = pos;
                                match = pattern.exec(text);
                                if (!match) {
                                    break;
                                }
                                var from = match.index + (lookbehind ? match[1].length : 0), to = match.index + match[0].length, k = i, p = pos;
                                for (var len = strarr.length; k < len && (p < to || (!strarr[k].type && !strarr[k - 1].greedy)); ++k) {
                                    p += strarr[k].length;
                                    // Move the index i to the element in strarr that is closest to from
                                    if (from >= p) {
                                        ++i;
                                        pos = p;
                                    }
                                }
                                /*
                                 * If strarr[i] is a Token, then the match starts inside another Token, which is invalid
                                 * If strarr[k - 1] is greedy we are in conflict with another greedy pattern
                                 */
                                if (strarr[i] instanceof Token || strarr[k - 1].greedy) {
                                    continue;
                                }
                                // Number of tokens to delete and replace with the new match
                                delNum = k - i;
                                str = text.slice(pos, p);
                                match.index -= pos;
                            }
                            if (!match) {
                                if (oneshot) {
                                    break;
                                }
                                continue;
                            }
                            if (lookbehind) {
                                lookbehindLength = match[1].length;
                            }
                            var from = match.index + lookbehindLength, match = match[0].slice(lookbehindLength), to = from + match.length, before = str.slice(0, from), after = str.slice(to);
                            var args = [i, delNum];
                            if (before) {
                                ++i;
                                pos += before.length;
                                args.push(before);
                            }
                            var wrapped = new Token(token, inside ? _.tokenize(match, inside) : match, alias, match, greedy);
                            args.push(wrapped);
                            if (after) {
                                args.push(after);
                            }
                            Array.prototype.splice.apply(strarr, args);
                            if (delNum != 1)
                                _.matchGrammar(text, strarr, grammar, i, pos, true, token);
                            if (oneshot)
                                break;
                        }
                    }
                }
            },
            tokenize: function (text, grammar, language) {
                var strarr = [text];
                var rest = grammar.rest;
                if (rest) {
                    for (var token in rest) {
                        grammar[token] = rest[token];
                    }
                    delete grammar.rest;
                }
                _.matchGrammar(text, strarr, grammar, 0, 0, false);
                return strarr;
            },
            hooks: {
                all: {},
                add: function (name, callback) {
                    var hooks = _.hooks.all;
                    hooks[name] = hooks[name] || [];
                    hooks[name].push(callback);
                },
                run: function (name, env) {
                    var callbacks = _.hooks.all[name];
                    if (!callbacks || !callbacks.length) {
                        return;
                    }
                    for (var i = 0, callback; callback = callbacks[i++];) {
                        callback(env);
                    }
                }
            }
        };
        var Token = _.Token = function (type, content, alias, matchedStr, greedy) {
            this.type = type;
            this.content = content;
            this.alias = alias;
            // Copy of the full string this token was created from
            this.length = (matchedStr || "").length | 0;
            this.greedy = !!greedy;
        };
        Token.stringify = function (o, language, parent) {
            if (typeof o == 'string') {
                return o;
            }
            if (_.util.type(o) === 'Array') {
                return o.map(function (element) {
                    return Token.stringify(element, language, o);
                }).join('');
            }
            var env = {
                type: o.type,
                content: Token.stringify(o.content, language, parent),
                tag: 'span',
                classes: ['token', o.type],
                attributes: {},
                language: language,
                parent: parent
            };
            if (o.alias) {
                var aliases = _.util.type(o.alias) === 'Array' ? o.alias : [o.alias];
                Array.prototype.push.apply(env.classes, aliases);
            }
            _.hooks.run('wrap', env);
            var attributes = Object.keys(env.attributes).map(function (name) {
                return name + '="' + (env.attributes[name] || '').replace(/"/g, '&quot;') + '"';
            }).join(' ');
            return '<' + env.tag + ' class="' + env.classes.join(' ') + '"' + (attributes ? ' ' + attributes : '') + '>' + env.content + '</' + env.tag + '>';
        };
        if (!_self.document) {
            if (!_self.addEventListener) {
                // in Node.js
                return _self.Prism;
            }
            if (!_.disableWorkerMessageHandler) {
                // In worker
                _self.addEventListener('message', function (evt) {
                    var message = JSON.parse(evt.data), lang = message.language, code = message.code, immediateClose = message.immediateClose;
                    _self.postMessage(_.highlight(code, _.languages[lang], lang));
                    if (immediateClose) {
                        _self.close();
                    }
                }, false);
            }
            return _self.Prism;
        }
        //Get current script and highlight
        var script = document.currentScript || [].slice.call(document.getElementsByTagName("script")).pop();
        if (script) {
            _.filename = script.src;
            if (!_.manual && !script.hasAttribute('data-manual')) {
                if (document.readyState !== "loading") {
                    if (window.requestAnimationFrame) {
                        window.requestAnimationFrame(_.highlightAll);
                    }
                    else {
                        window.setTimeout(_.highlightAll, 16);
                    }
                }
                else {
                    document.addEventListener('DOMContentLoaded', _.highlightAll);
                }
            }
        }
        return _self.Prism;
    })();
    if (module.exports) {
        module.exports = Prism;
    }
    // hack for components to work correctly in node.js
    if (typeof commonjsGlobal !== 'undefined') {
        commonjsGlobal.Prism = Prism;
    }
    /* **********************************************
         Begin prism-markup.js
    ********************************************** */
    Prism.languages.markup = {
        'comment': /<!--[\s\S]*?-->/,
        'prolog': /<\?[\s\S]+?\?>/,
        'doctype': /<!DOCTYPE[\s\S]+?>/i,
        'cdata': /<!\[CDATA\[[\s\S]*?]]>/i,
        'tag': {
            pattern: /<\/?(?!\d)[^\s>\/=$<]+(?:\s+[^\s>\/=]+(?:=(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s'">=]+))?)*\s*\/?>/i,
            inside: {
                'tag': {
                    pattern: /^<\/?[^\s>\/]+/i,
                    inside: {
                        'punctuation': /^<\/?/,
                        'namespace': /^[^\s>\/:]+:/
                    }
                },
                'attr-value': {
                    pattern: /=(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s'">=]+)/i,
                    inside: {
                        'punctuation': [
                            /^=/,
                            {
                                pattern: /(^|[^\\])["']/,
                                lookbehind: true
                            }
                        ]
                    }
                },
                'punctuation': /\/?>/,
                'attr-name': {
                    pattern: /[^\s>\/]+/,
                    inside: {
                        'namespace': /^[^\s>\/:]+:/
                    }
                }
            }
        },
        'entity': /&#?[\da-z]{1,8};/i
    };
    Prism.languages.markup['tag'].inside['attr-value'].inside['entity'] =
        Prism.languages.markup['entity'];
    // Plugin to make entity title show the real entity, idea by Roman Komarov
    Prism.hooks.add('wrap', function (env) {
        if (env.type === 'entity') {
            env.attributes['title'] = env.content.replace(/&amp;/, '&');
        }
    });
    Prism.languages.xml = Prism.languages.markup;
    Prism.languages.html = Prism.languages.markup;
    Prism.languages.mathml = Prism.languages.markup;
    Prism.languages.svg = Prism.languages.markup;
    /* **********************************************
         Begin prism-css.js
    ********************************************** */
    Prism.languages.css = {
        'comment': /\/\*[\s\S]*?\*\//,
        'atrule': {
            pattern: /@[\w-]+?.*?(?:;|(?=\s*\{))/i,
            inside: {
                'rule': /@[\w-]+/
                // See rest below
            }
        },
        'url': /url\((?:(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1|.*?)\)/i,
        'selector': /[^{}\s][^{};]*?(?=\s*\{)/,
        'string': {
            pattern: /("|')(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
            greedy: true
        },
        'property': /[-_a-z\xA0-\uFFFF][-\w\xA0-\uFFFF]*(?=\s*:)/i,
        'important': /\B!important\b/i,
        'function': /[-a-z0-9]+(?=\()/i,
        'punctuation': /[(){};:]/
    };
    Prism.languages.css['atrule'].inside.rest = Prism.util.clone(Prism.languages.css);
    if (Prism.languages.markup) {
        Prism.languages.insertBefore('markup', 'tag', {
            'style': {
                pattern: /(<style[\s\S]*?>)[\s\S]*?(?=<\/style>)/i,
                lookbehind: true,
                inside: Prism.languages.css,
                alias: 'language-css',
                greedy: true
            }
        });
        Prism.languages.insertBefore('inside', 'attr-value', {
            'style-attr': {
                pattern: /\s*style=("|')(?:\\[\s\S]|(?!\1)[^\\])*\1/i,
                inside: {
                    'attr-name': {
                        pattern: /^\s*style/i,
                        inside: Prism.languages.markup.tag.inside
                    },
                    'punctuation': /^\s*=\s*['"]|['"]\s*$/,
                    'attr-value': {
                        pattern: /.+/i,
                        inside: Prism.languages.css
                    }
                },
                alias: 'language-css'
            }
        }, Prism.languages.markup.tag);
    }
    /* **********************************************
         Begin prism-clike.js
    ********************************************** */
    Prism.languages.clike = {
        'comment': [
            {
                pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/,
                lookbehind: true
            },
            {
                pattern: /(^|[^\\:])\/\/.*/,
                lookbehind: true
            }
        ],
        'string': {
            pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
            greedy: true
        },
        'class-name': {
            pattern: /((?:\b(?:class|interface|extends|implements|trait|instanceof|new)\s+)|(?:catch\s+\())[\w.\\]+/i,
            lookbehind: true,
            inside: {
                punctuation: /[.\\]/
            }
        },
        'keyword': /\b(?:if|else|while|do|for|return|in|instanceof|function|new|try|throw|catch|finally|null|break|continue)\b/,
        'boolean': /\b(?:true|false)\b/,
        'function': /[a-z0-9_]+(?=\()/i,
        'number': /\b-?(?:0x[\da-f]+|\d*\.?\d+(?:e[+-]?\d+)?)\b/i,
        'operator': /--?|\+\+?|!=?=?|<=?|>=?|==?=?|&&?|\|\|?|\?|\*|\/|~|\^|%/,
        'punctuation': /[{}[\];(),.:]/
    };
    /* **********************************************
         Begin prism-javascript.js
    ********************************************** */
    Prism.languages.javascript = Prism.languages.extend('clike', {
        'keyword': /\b(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|var|void|while|with|yield)\b/,
        'number': /\b-?(?:0[xX][\dA-Fa-f]+|0[bB][01]+|0[oO][0-7]+|\d*\.?\d+(?:[Ee][+-]?\d+)?|NaN|Infinity)\b/,
        // Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
        'function': /[_$a-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\s*\()/i,
        'operator': /-[-=]?|\+[+=]?|!=?=?|<<?=?|>>?>?=?|=(?:==?|>)?|&[&=]?|\|[|=]?|\*\*?=?|\/=?|~|\^=?|%=?|\?|\.{3}/
    });
    Prism.languages.insertBefore('javascript', 'keyword', {
        'regex': {
            pattern: /(^|[^/])\/(?!\/)(\[[^\]\r\n]+]|\\.|[^/\\\[\r\n])+\/[gimyu]{0,5}(?=\s*($|[\r\n,.;})]))/,
            lookbehind: true,
            greedy: true
        },
        // This must be declared before keyword because we use "function" inside the look-forward
        'function-variable': {
            pattern: /[_$a-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\s*=\s*(?:function\b|(?:\([^()]*\)|[_$a-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*)\s*=>))/i,
            alias: 'function'
        }
    });
    Prism.languages.insertBefore('javascript', 'string', {
        'template-string': {
            pattern: /`(?:\\[\s\S]|[^\\`])*`/,
            greedy: true,
            inside: {
                'interpolation': {
                    pattern: /\$\{[^}]+\}/,
                    inside: {
                        'interpolation-punctuation': {
                            pattern: /^\$\{|\}$/,
                            alias: 'punctuation'
                        },
                        rest: Prism.languages.javascript
                    }
                },
                'string': /[\s\S]+/
            }
        }
    });
    if (Prism.languages.markup) {
        Prism.languages.insertBefore('markup', 'tag', {
            'script': {
                pattern: /(<script[\s\S]*?>)[\s\S]*?(?=<\/script>)/i,
                lookbehind: true,
                inside: Prism.languages.javascript,
                alias: 'language-javascript',
                greedy: true
            }
        });
    }
    Prism.languages.js = Prism.languages.javascript;
    /* **********************************************
         Begin prism-file-highlight.js
    ********************************************** */
    (function () {
        if (typeof self === 'undefined' || !self.Prism || !self.document || !document.querySelector) {
            return;
        }
        self.Prism.fileHighlight = function () {
            var Extensions = {
                'js': 'javascript',
                'py': 'python',
                'rb': 'ruby',
                'ps1': 'powershell',
                'psm1': 'powershell',
                'sh': 'bash',
                'bat': 'batch',
                'h': 'c',
                'tex': 'latex'
            };
            Array.prototype.slice.call(document.querySelectorAll('pre[data-src]')).forEach(function (pre) {
                var src = pre.getAttribute('data-src');
                var language, parent = pre;
                var lang = /\blang(?:uage)?-(?!\*)(\w+)\b/i;
                while (parent && !lang.test(parent.className)) {
                    parent = parent.parentNode;
                }
                if (parent) {
                    language = (pre.className.match(lang) || [, ''])[1];
                }
                if (!language) {
                    var extension = (src.match(/\.(\w+)$/) || [, ''])[1];
                    language = Extensions[extension] || extension;
                }
                var code = document.createElement('code');
                code.className = 'language-' + language;
                pre.textContent = '';
                code.textContent = 'Loading…';
                pre.appendChild(code);
                var xhr = new XMLHttpRequest();
                xhr.open('GET', src, true);
                xhr.onreadystatechange = function () {
                    if (xhr.readyState == 4) {
                        if (xhr.status < 400 && xhr.responseText) {
                            code.textContent = xhr.responseText;
                            Prism.highlightElement(code);
                        }
                        else if (xhr.status >= 400) {
                            code.textContent = '✖ Error ' + xhr.status + ' while fetching file: ' + xhr.statusText;
                        }
                        else {
                            code.textContent = '✖ Error: File does not exist or is empty';
                        }
                    }
                };
                xhr.send(null);
            });
        };
        document.addEventListener('DOMContentLoaded', self.Prism.fileHighlight);
    })();
});
(function (Prism) {
    Prism.languages.sass = Prism.languages.extend('css', {
        // Sass comments don't need to be closed, only indented
        'comment': {
            pattern: /^([ \t]*)\/[\/*].*(?:(?:\r?\n|\r)\1[ \t]+.+)*/m,
            lookbehind: true
        }
    });
    Prism.languages.insertBefore('sass', 'atrule', {
        // We want to consume the whole line
        'atrule-line': {
            // Includes support for = and + shortcuts
            pattern: /^(?:[ \t]*)[@+=].+/m,
            inside: {
                'atrule': /(?:@[\w-]+|[+=])/m
            }
        }
    });
    delete Prism.languages.sass.atrule;
    var variable = /\$[-\w]+|#\{\$[-\w]+\}/;
    var operator = [
        /[+*\/%]|[=!]=|<=?|>=?|\b(?:and|or|not)\b/,
        {
            pattern: /(\s+)-(?=\s)/,
            lookbehind: true
        }
    ];
    Prism.languages.insertBefore('sass', 'property', {
        // We want to consume the whole line
        'variable-line': {
            pattern: /^[ \t]*\$.+/m,
            inside: {
                'punctuation': /:/,
                'variable': variable,
                'operator': operator
            }
        },
        // We want to consume the whole line
        'property-line': {
            pattern: /^[ \t]*(?:[^:\s]+ *:.*|:[^:\s]+.*)/m,
            inside: {
                'property': [
                    /[^:\s]+(?=\s*:)/,
                    {
                        pattern: /(:)[^:\s]+/,
                        lookbehind: true
                    }
                ],
                'punctuation': /:/,
                'variable': variable,
                'operator': operator,
                'important': Prism.languages.sass.important
            }
        }
    });
    delete Prism.languages.sass.property;
    delete Prism.languages.sass.important;
    // Now that whole lines for other patterns are consumed,
    // what's left should be selectors
    delete Prism.languages.sass.selector;
    Prism.languages.insertBefore('sass', 'punctuation', {
        'selector': {
            pattern: /([ \t]*)\S(?:,?[^,\r\n]+)*(?:,(?:\r?\n|\r)\1[ \t]+\S(?:,?[^,\r\n]+)*)*/,
            lookbehind: true
        }
    });
}(Prism));
Prism.languages.typescript = Prism.languages.extend('javascript', {
    // From JavaScript Prism keyword list and TypeScript language spec: https://github.com/Microsoft/TypeScript/blob/master/doc/spec.md#221-reserved-words
    'keyword': /\b(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|var|void|while|with|yield|false|true|module|declare|constructor|string|Function|any|number|boolean|Array|symbol|namespace|abstract|require|type)\b/
});
Prism.languages.ts = Prism.languages.typescript;
var Markdown = /** @class */ (function () {
    function Markdown(hostRef) {
        registerInstance(this, hostRef);
    }
    Markdown.prototype.componentDidRender = function () {
        this.renderMarkup();
    };
    Markdown.prototype.renderMarkup = function () {
        this.element.innerHTML = marked(this.precompile(this.data));
        prism.highlightAll(false);
    };
    Markdown.prototype.precompile = function (markdown) {
        if (!markdown) {
            return '';
        }
        markdown = (markdown.default) ? markdown.default : markdown;
        var indentStart;
        return markdown
            .replace(/\&gt;/g, '>')
            .split('\n')
            .map(function (line) {
            // find position of 1st non-whitespace character
            // to determine the markdown indentation start
            if (line.length > 0 && isNaN(indentStart)) {
                indentStart = line.search(/\S|$/);
            }
            // remove whitespaces before indentation start
            return indentStart ? line.substring(indentStart) : line;
        }).join('\n');
    };
    Object.defineProperty(Markdown.prototype, "element", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Markdown, "style", {
        get: function () { return "ad-markdown{display:block}ad-markdown code[class*=language-],ad-markdown pre[class*=language-]{border-radius:.25rem;color:var(--anj-primary);background:none;text-align:left;white-space:pre;word-spacing:normal;word-break:normal;word-wrap:normal;line-height:1.5;-moz-tab-size:4;-o-tab-size:4;tab-size:4;-webkit-hyphens:none;-ms-hyphens:none;hyphens:none}ad-markdown pre[class*=language-]{padding:1rem;margin:2rem 0;overflow:auto}ad-markdown :not(pre)>code[class*=language-],ad-markdown pre[class*=language-]{background:var(--anj-background);border:1px dashed var(--anj-border)}ad-markdown :not(pre)>code[class*=language-]{padding:.1em;border-radius:.3em;white-space:normal}ad-markdown .token.inserted,ad-markdown .token.punctuation{color:var(--anj-secondary-dark)}ad-markdown .token.attr-value,ad-markdown .token.string{color:var(--anj-dark)}ad-markdown .token.attr-name,ad-markdown .token.char,ad-markdown .token.class-name,ad-markdown .token.constant,ad-markdown .token.function,ad-markdown .token.function-name,ad-markdown .token.property,ad-markdown .token.regex,ad-markdown .token.symbol,ad-markdown .token.variable{color:var(--anj-primary)}ad-markdown .token.atrule,ad-markdown .token.boolean,ad-markdown .token.builtin,ad-markdown .token.deleted,ad-markdown .token.important,ad-markdown .token.keyword,ad-markdown .token.namespace,ad-markdown .token.number,ad-markdown .token.selector,ad-markdown .token.tag{color:var(--anj-highlight-dark)}ad-markdown .token.block-comment,ad-markdown .token.cdata,ad-markdown .token.comment,ad-markdown .token.doctype,ad-markdown .token.entity,ad-markdown .token.operator,ad-markdown .token.prolog,ad-markdown .token.url{color:var(--anj-neutral)}ad-markdown .token.bold,ad-markdown .token.important{font-weight:700}ad-markdown .token.italic{font-style:italic}ad-markdown .token.entity{cursor:help}ad-markdown blockquote{padding:0 1em;color:var(--anj-primary);border-left:.25em solid var(--anj-neutral)}ad-markdown h1{font-size:2rem;font-weight:600;letter-spacing:var(--anj-spacing-wide);margin:0 0 1rem;padding:0}ad-markdown h2{font-size:1.5rem}ad-markdown h2,ad-markdown h3{font-weight:400;margin:1rem 0;padding:0}ad-markdown h3{font-size:1.25rem}ad-markdown h4{font-size:1rem}ad-markdown h4,ad-markdown h5{font-weight:400;margin:1rem 0;padding:0}ad-markdown h5{font-size:.875rem}"; },
        enumerable: true,
        configurable: true
    });
    return Markdown;
}());
var MethodDef = /** @class */ (function () {
    function MethodDef(hostRef) {
        registerInstance(this, hostRef);
    }
    MethodDef.prototype.nameless = function (name) {
        return "(" + name.split('(')[1];
    };
    MethodDef.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Method\u00A0"), h("ad-api-name", null, this.method.name), h("ad-type-def", null, this.nameless(this.method.signature))),
            h("p", null, this.method.docs)
        ];
    };
    Object.defineProperty(MethodDef, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return MethodDef;
}());
var OutputDef = /** @class */ (function () {
    function OutputDef(hostRef) {
        registerInstance(this, hostRef);
    }
    OutputDef.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Output\u00A0"), h("ad-api-name", null, this.output.name), h("ad-type-def", null, this.output.type)),
            h("p", null, this.output.docs)
        ];
    };
    Object.defineProperty(OutputDef, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return OutputDef;
}());
var PropDef = /** @class */ (function () {
    function PropDef(hostRef) {
        registerInstance(this, hostRef);
    }
    PropDef.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Prop\u00A0"), h("ad-api-name", null, this.prop.name), h("ad-type-def", null, this.prop.type)),
            h("p", null, this.prop.docs)
        ];
    };
    Object.defineProperty(PropDef, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return PropDef;
}());
var RealTime = /** @class */ (function () {
    function RealTime(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(RealTime, "style", {
        get: function () { return "ad-real-time{border:1px dashed var(--anj-border);border-radius:.25rem;display:block;margin-top:1.5rem;overflow-x:auto;padding:1rem;width:100%}"; },
        enumerable: true,
        configurable: true
    });
    return RealTime;
}());
var Toc = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.activeId = '#overview';
        /**
         * The object map of usa cases to their markdown
         */
        this.docs = {};
        /**
         * The object map of usa cases to their markdown
         */
        this.keys = [];
    }
    class_1.prototype.onDemosChange = function () {
        this.sectionIds = ['#overview'].concat(this.keys.map(function (d) { return "#" + d; })).concat('#api');
    };
    class_1.prototype.connectedCallback = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.navigate = debounce(this.navigate.bind(this), 100);
                this.onScroll = debounce(this.onScroll.bind(this), 25);
                this.onDemosChange();
                if (window.location.hash) {
                    return [2 /*return*/, this.navigate()];
                }
                return [2 /*return*/];
            });
        });
    };
    class_1.prototype.onScroll = function () {
        var els = this.sectionIds.map(function (id) { return document.querySelector(id); });
        var closest = els[0];
        els.slice(1).forEach(function (el) {
            if (el && Math.abs(window.scrollY - el.offsetTop) < Math.abs(window.scrollY - closest.offsetTop)) {
                closest = el;
            }
        });
        this.activeId = "#" + closest.getAttribute('id');
    };
    class_1.prototype.parseTitle = function (id) {
        var usage = id.replace('#', '');
        var doc = this.docs[usage];
        return doc ? doc.split(/##(.*?)\n/).find(function (p) { return p !== ''; }).trim() : usage;
    };
    class_1.prototype.anchorClass = function (usage) {
        return usage === this.activeId ? 'anj-active' : '';
    };
    class_1.prototype.navigate = function () {
        var _this = this;
        return new Promise(function (resolve) {
            window.setTimeout(function () {
                _this.activeId = window.location.hash;
                var el = document.querySelector(_this.activeId);
                if (el) {
                    window.scrollTo(0, el.offsetTop);
                }
                resolve();
            }, 500);
        });
    };
    class_1.prototype.render = function () {
        var _this = this;
        if (!this.sectionIds) {
            return;
        }
        var path = window.location.pathname;
        return (h("div", { class: "anj-toc" }, this.sectionIds.map(function (id) { return h("a", { href: "" + path + id, onClick: function () { return _this.activeId = id; }, class: _this.anchorClass(id) }, _this.parseTitle(id)); })));
    };
    Object.defineProperty(class_1, "watchers", {
        get: function () {
            return {
                "keys": ["onDemosChange"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "style", {
        get: function () { return "ad-toc{display:block;position:relative}ad-toc .anj-toc{padding:1rem 0;position:fixed;top:3rem}ad-toc a{display:block;font-size:.75rem;margin-bottom:.5rem;text-transform:capitalize;-webkit-transition:color .2s ease;transition:color .2s ease}ad-toc a:focus{text-decoration:underline}ad-toc a:active{text-decoration:none}ad-toc a.anj-active,ad-toc a.anj-active:focus,ad-toc a.anj-active:hover{color:var(--anj-primary);text-decoration:none}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
var debounce = function (func, wait) {
    if (wait === void 0) { wait = 0; }
    var timer;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        clearTimeout(timer);
        timer = setTimeout.apply(void 0, __spreadArrays([func, wait], args));
    };
};
var TypeDef = /** @class */ (function () {
    function TypeDef(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(TypeDef, "style", {
        get: function () { return "ad-type-def{color:var(--anj-neutral-dark);font-size:.75rem}"; },
        enumerable: true,
        configurable: true
    });
    return TypeDef;
}());
export { Api as ad_api, ApiName as ad_api_name, ArgDef as ad_arg_def, Decorator as ad_decorator, EventDef as ad_event_def, InputDef as ad_input_def, Markdown as ad_markdown, MethodDef as ad_method_def, OutputDef as ad_output_def, PropDef as ad_prop_def, RealTime as ad_real_time, Toc as ad_toc, TypeDef as ad_type_def };
